<?php
/*
 *      Patrick Bores - WebUserPrefs - SpamAssassin user_prefs file editor
 *      Copyright (C) 2003  Patrick Bores
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License
 *      as published by the Free Software Foundation; either version 2
 *      of the License, or (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


// POP3 Authentication Module for WebUserPrefs
// by Patrick Bores
//
// Requires: IMAP functions compiled into PHP
// 
// This authentication module prompts for a username and
// a password, and attempts to log into a POP3 server using
// the information entered. If the login failed, the user is
// prompted again. If the the login succeeded, the WebUserPrefs
// page is rendered. Since the $auth_user variable remains set,
// it can be used when setting configuration variables in config.php.

// Configuration Section
// Configure the following variables for POP3 authentication.

$pop3_server	= "localhost";
$pop3_port	= "110";
$basic_realm	= "SpamAssassin Preferences";
$return_url	= "http://www.spamassassin.org";

// End of Configuration Section
// No modifications are required below this line.

$auth_user = $_SERVER["PHP_AUTH_USER"];
$auth_pass = $_SERVER["PHP_AUTH_PW"];

if(!$auth_user || !$auth_pass){
		login_prompt();
}else{
	$imap_string = "{".$pop3_server.":".$pop3_port."/pop3}INBOX";
	if(!imap_open("$imap_string",$auth_user,$auth_pass)){
		login_prompt();
	}
}

function login_prompt(){

	global $basic_realm,$return_url;

	Header("WWW-Authenticate: Basic realm=\"$basic_realm\"");
	Header("HTTP/1.0 401 Unauthorized");
	echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=$return_url\">";

	exit;
}

?>
